
#ifndef __DECSSAUTH_H__
#define __DECSSAUTH_H__

#include <windows.h>
#include "DeCSS.h"

typedef struct
{
	int				CmdSize;	// Command Size
	unsigned char	Cmd[16];	// Command
	int				BufSize;	// Buffer Size
	unsigned char	*Buffer;	// Pointer to a buffer of size BufSize
} packet_command;

class DeCSSauth : public DeCSS
{
public:
	DeCSSauth();
	~DeCSSauth();
	virtual int AuthorizeDrive(char *FileName);
	virtual int GetStreamKey(char *FileName,CSS_Key *StreamKey);
	virtual int IsCiphered();

private:
	HANDLE		hEventEnd;
	CSS_Key		DiscKey,TitleKey;
	int			Host,Target,Lun;
	int DVD_QUEUE_COMMAND(packet_command *pc);
	void setup_report_key(packet_command *pc, unsigned agid, unsigned type);
	void setup_send_key(packet_command *pc, unsigned agid, unsigned type);
	int IsWindowsNTor9x();
	int GetDriveInfoNT(char DriveLetter);
	int GetDriveInfo9x(char DriveLetter);
};

#endif